#include "RecvFileThread.h"
#include "SendRecvThread.h"		// CSendRecvThreadg
#include "QueingArray.h"

#define RECV_FILE_CMD_QUE_SIZE	100			// t@CMR}hpPbgpPbgi[


CRecvFileThread::CRecvFileThread(CSendRecvThread *pCSendRecvThread, LPSTR pszFileName)
{
	// p[^L
	m_pCSendRecvThread = pCSendRecvThread;
	m_pszFileName = (LPSTR)calloc(strlen(pszFileName) + 1, sizeof(char));
	DISABLE_C4996
	strcpy(m_pszFileName, pszFileName);
	ENABLE_C4996

	// ϐ̏
	m_pCQueingArrayCmd = new CQueingArray(RECV_FILE_CMD_QUE_SIZE);
	m_fIamZombie = FALSE;
	m_iRecvFileStatus = RECV_FILE_STAT_IDLE;		// 
	m_bFileSizeRes = 0;								// t@CM MTCYv(0:l ErrorCode)
	m_lFileSize = 0;								// MTCY (G[:0 ݎ:ۂ̃TCY)
	m_bAbortRes = 0;								// t@CMfv(0:l ErrorCode)
	m_dwSendReqTime = 0;							// ҂^CAEĝߗvs
	m_fdDstFile = -1;								// Mt@CfBXNv^
}


CRecvFileThread::~CRecvFileThread()
{
	SAFE_FREE(m_pszFileName)
	SAFE_DELETE(m_pCQueingArrayCmd)									//
}

UINT CRecvFileThread::DoWork()
{
	int			iRet = -1;

	// t@Copen
	DISABLE_C4996
	m_fdDstFile = _open(m_pszFileName, _O_CREAT | _O_WRONLY | _O_TRUNC | _O_BINARY, _S_IREAD | _S_IWRITE);
	ENABLE_C4996
	// opens͉Ȃ
	if(m_fdDstFile == -1)
	{
		fprintf(stderr, "t@CopenG[ %s\n", m_pszFileName);
		goto L_END;
	}

	while (!m_fStopFlag)
	{
		Sleep(5);							// Sleepđ̃XbhɃ`X^
		if ((iRet = AnalyzeCmd()) == -1)	// Ԓl-1̎G[
			break;
		if ((iRet = DoSequence()) == -1)
			break;
		if ((m_iRecvFileStatus == RECV_FILE_STAT_END) || (m_iRecvFileStatus == RECV_FILE_STAT_ABORTED))
			break;
	}
L_END:
	// t@Cclose
	if (m_fdDstFile != -1)
	{
		_close(m_fdDstFile);
		if((iRet == -1) || (m_iRecvFileStatus == RECV_FILE_STAT_ABORTED))
			_unlink(m_pszFileName);
	}
	m_fIamZombie = TRUE;		// t@CM/sŃ]r
	return((iRet != -1) ? 0 : -1);
}


//----------------------------------------------
// function
//		t@CMR}h/̉
// parameter
//		Ȃ
// retun
//		0:t@CMR}hpPbgȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::AnalyzeCmd()
{
	int			iRet = 0, iSize;
	LPBYTE		pbPacketData = NULL;
	int			iPacketSize;
	HeaderRec* pHeader;
	WORD		wCmd;

	if ((iSize = m_pCQueingArrayCmd->GetSize()) == 0)
		goto L_END;
	// pPbg̓ǂݍ
	m_pCQueingArrayCmd->PopData(&pbPacketData, &iPacketSize);
	// R}h^Cv𒲂ׂ
	pHeader = (HeaderRec*)pbPacketData;
	wCmd = ntohs(pHeader->wCommand);

	switch (wCmd)
	{
		case CMD_RECV_FILE_SIZE_RES:			// MTCYvM
			iRet = RecvFileSizeResPacket((RecvFileSizeResRec *)pbPacketData);
			break;
		case CMD_RECV_FILE_ING:					// t@CM(t@CMJnv/t@CM->t@CM)
			iRet = RecvIngPacket((RecvFileIngRec *)pbPacketData);
			break;
		case CMD_RECV_FILE_END_REQ:				// t@CMvM(t@CM->t@CM->)
			iRet = RecvEndPacket((RecvFileEndReqRec *)pbPacketData);
			break;
		case CMD_RECV_FILE_ABORT_RES:			// MfvM(t@CM->)
			iRet = 1;
			m_bAbortRes = ((RecvFileResRec*)pbPacketData)->bStatus;
			break;
		default:
			iRet = -1;
			break;
	}
L_END:
	SAFE_FREE(pbPacketData)
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJڏԂɉs
// parameter
//		Ȃ
// return
//		0:Ȃ 1:s -1:G[
//----------------------------------------------
int CRecvFileThread::DoSequence()
{
	int iRet = 0;

	switch (m_iRecvFileStatus)
	{
		case RECV_FILE_STAT_IDLE:									// ->MTCY҂
			if ((iRet = SendFileSizePacket(m_pszFileName)) == 1)	// MTCYvpPbg𑗐M
			{
				m_iRecvFileStatus = RECV_FILE_STAT_SIZE;
				m_dwSendReqTime = timeGetTime();
			}
			break;
		case RECV_FILE_STAT_SIZE:									// MTCY҂->t@CMJnv
			if ((iRet = CheckFileSizeRes(TIMEOUT_FOR_RES)) == 1)	// ʃ`FbN
			{
				if (SendStartPacket(m_pszFileName, m_lFileSize) == TRUE)
				{
					m_iRecvFileStatus = RECV_FILE_STAT_START;
					iRet = 1;
				}
			}
			break;
		case RECV_FILE_STAT_ABORT:					// fvM
			if (SendAbortPacket() == TRUE)
			{
				m_iRecvFileStatus = RECV_FILE_STAT_ABORTING;
				m_dwSendReqTime = timeGetTime();
				iRet = 1;
			}
			break;

		case RECV_FILE_STAT_ABORTING:				// f҂->I
			if (((iRet = CheckAbortRes(TIMEOUT_FOR_RES)) == 1) || (iRet == -1))
			{
				fprintf(stderr, "t@CMf");
				m_iRecvFileStatus = RECV_FILE_STAT_ABORTED;
				iRet = 1;
			}
			break;
		default:
			break;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMTCYv
// parameter
//		RecvFileSizeResRec *pbPacket	[in]MpPbg
// return
//		1
//----------------------------------------------
int CRecvFileThread::RecvFileSizeResPacket(RecvFileSizeResRec *pbPacket)
{
	int			iRet = 1;

	m_bFileSizeRes = pbPacket->bStatus;
	m_lFileSize = atol(pbPacket->FileInfo.szFileSize);
	return(iRet);
}

//----------------------------------------------
// function
//		t@CM
// parameter
//		RecvFileIngRec *pbPacket	[in]MpPbg
// return
//		1
//----------------------------------------------
int CRecvFileThread::RecvIngPacket(RecvFileIngRec *pbPacket)
{
	int			iRet = 1;
	long		lDataSize, lOffset;
	BYTE		bStatus = ERR_SUCCESS;							// ̏

	fprintf(stderr, "Ing %s %s ", pbPacket->Stat.szOffset, pbPacket->Stat.szSize);

	if (m_iRecvFileStatus == RECV_FILE_STAT_START)
		m_iRecvFileStatus = RECV_FILE_STAT_ING;

	// f͏݂sȂ
	if ((m_iRecvFileStatus == RECV_FILE_STAT_ABORT) || (m_iRecvFileStatus == RECV_FILE_STAT_ABORTING))
	{
		fprintf(stderr, "t@CMf");
		goto L_END;
	}

	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
	{
		// JڏԃG[͒f->I
		bStatus = ERR_SEQUENCE;
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂĒf->I
		if (_lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			// G[͒f->I
			bStatus = ERR_FILE_SEEK;
			goto L_END;
		}
		if (_write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			// G[͒f->I
			bStatus = ERR_FILE_WRITE;
			goto L_END;
		}
	}
L_END:
	if (bStatus != ERR_SUCCESS)
	{
		// bStatus  ERR_SUCCESSȊO̎AAbortvM
		m_iRecvFileStatus = RECV_FILE_STAT_ABORT;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CM
// parameter
//		RecvFileEndReqRec *pbPacket	[in]MpPbg
// return
//		1/-1
//----------------------------------------------
int CRecvFileThread::RecvEndPacket(RecvFileEndReqRec *pbPacket)
{
	int			iRet = -1;
	long		lDataSize, lOffset;
	BYTE		bStatus = ERR_SUCCESS;

	fprintf(stderr, "t@CM %s %s(%u) ", pbPacket->Stat.szOffset, pbPacket->Stat.szSize, timeGetTime());

	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
	{
		// t@CJڃG[I
		bStatus = ERR_SEQUENCE;
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂďI
		if (_lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			bStatus = ERR_FILE_SEEK;
			goto L_END;
		}
		if (_write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			bStatus = ERR_FILE_WRITE;
			goto L_END;
		}
	}
	iRet = 1;
L_END:
	SendEndResPacket(bStatus);									// MvM
	m_iRecvFileStatus = RECV_FILE_STAT_END;
	return(iRet);
}


//----------------------------------------------
// function
//		t@CMvɑ΂鉞𑗐M
// parameter
//		BYTE bStatus	[in] ERR_SUCCESS/ERR_SEQUENCE/ERR_FILE_SEEK/ERR_FILE_WRITE
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendEndResPacket(BYTE bStatus)
{
	BOOL	fRet = FALSE;
	RecvFileResRec	*pRecvFileEndRes = NULL;
	int		iPacketSize;

	iPacketSize = sizeof(RecvFileResRec);
	pRecvFileEndRes = (RecvFileResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileEndRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileEndRes->header.wCommand = htons(CMD_RECV_FILE_END_RES);
	pRecvFileEndRes->header.wDataLen = htons(sizeof(BYTE));

	pRecvFileEndRes->bStatus = bStatus;

	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileEndRes, iPacketSize);
	SAFE_FREE(pRecvFileEndRes)
	return(fRet);
}

//----------------------------------------------
// function
//		t@CTCYvR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C
// retun
//		-1:G[ 1:
//----------------------------------------------
int CRecvFileThread::SendFileSizePacket(LPSTR pszFileName)
{
	int			iRet = -1;
	RecvFileSizeReqRec	*pRecvFileSizeReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileSizeReqRec);
	pRecvFileSizeReq = (RecvFileSizeReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileSizeReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileSizeReq->header.wCommand = htons(CMD_RECV_FILE_SIZE_REQ);
	pRecvFileSizeReq->header.wDataLen = htons(sizeof(FileInfoRec));

	fprintf(stderr, "FileSizeReq %s", pszFileName);
	// f[^Ƀf[^i[(t@C)
	// t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);

	memcpy(pRecvFileSizeReq->FileInfo.szFileName, pbDest, iSize);

	// t@CTCYvpPbg̑M
	if(m_pCSendRecvThread->SetSendData((char *)pRecvFileSizeReq, iPacketSize) == TRUE)
		iRet = 1;
	SAFE_FREE(pbDest)
	SAFE_FREE(pRecvFileSizeReq);
	return(iRet);
}


//----------------------------------------------
// function
//		t@CMJnR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C
//		int		iFileLength	[in]t@C/0:t@CM{Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendStartPacket(LPSTR pszFileName, int iFileLength)
{
	BOOL		fRet = FALSE;
	RecvFileStartReqRec	*pRecvFileStartReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileStartReqRec);
	pRecvFileStartReq = (RecvFileStartReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileStartReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileStartReq->header.wCommand = htons(CMD_RECV_FILE_START_REQ);
	pRecvFileStartReq->header.wDataLen = htons(sizeof(FileInfoRec));

	fprintf(stderr, "t@CMJn %s %d(%u)", pszFileName, iFileLength, timeGetTime());
	// f[^Ƀf[^i[(t@CTCYAt@C)
	// t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);

	memcpy(pRecvFileStartReq->FileInfo.szFileName, pbDest, iSize);
	DISABLE_C4996
	sprintf(pRecvFileStartReq->FileInfo.szFileSize, "%d", iFileLength);
	ENABLE_C4996

	// t@CMJnvpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileStartReq, iPacketSize);

	SAFE_FREE(pbDest)
	SAFE_FREE(pRecvFileStartReq);
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒fvM
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendAbortPacket()
{
	BOOL		fRet = FALSE;
	RecvFileAbortReqRec	*pRecvFileAbortReq = NULL;
	int			iPacketSize;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileAbortReqRec);
	pRecvFileAbortReq = (RecvFileAbortReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileAbortReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileAbortReq->header.wCommand = htons(CMD_RECV_FILE_ABORT_REQ);
	pRecvFileAbortReq->header.wDataLen = htons(0);

	fprintf(stderr, "t@CMfvM");

	// t@CMfpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileAbortReq, iPacketSize);
	SAFE_FREE(pRecvFileAbortReq);
	return(fRet);
}

//----------------------------------------------
// function
//		t@CMTCYv`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 1: -1:s܂̓^CAEg 2:t@C݂Ȃ
//----------------------------------------------
int	CRecvFileThread::CheckFileSizeRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwSendReqTime) >= dwTimeOut)			// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_bFileSizeRes == 0)						// Ȃ
		goto L_END;
	else if ((m_bFileSizeRes == ERR_SUCCESS) && (m_lFileSize > 0))			// 
		iRet = 1;
	else																	// G[
	{
		fprintf(stderr, "Err:CheckFileSizeRes %d %d\n", (char)m_bFileSizeRes, m_lFileSize);
		iRet = -1;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CM̒fv`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 2: -1:s܂̓^CAEg
//----------------------------------------------
int	CRecvFileThread::CheckAbortRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwSendReqTime) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_bAbortRes == 0)						// Ȃ
		goto L_END;
	else if (m_bAbortRes == ERR_SUCCESS)		// 
		iRet = 1;
	else										// G[
	{
		fprintf(stderr, "Err:CheckAbortRes %d\n", (char)m_bAbortRes);
		iRet = -1;
	}
L_END:
	if (iRet != 0)
	{
		if (m_fdDstFile != -1)
		{
			_close(m_fdDstFile);
			_unlink(m_pszFileName);
		}
		m_fdDstFile = -1;
	}
	return(iRet);
}


//----------------------------------------------
// function
//		Mf
//		JڏԕύXAfpPbgM
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::RecvFileAbort()
{
	BOOL		fRet = FALSE;

	// t@CM̎f
	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
		goto L_END;

	m_iRecvFileStatus = RECV_FILE_STAT_ABORT;
	fRet = TRUE;
L_END:
	return(fRet);
}


//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//	  TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::IsZombie()
{
	BOOL	fRet;

	fRet = m_fIamZombie;
	return(fRet);
}
