#include "SendFileThread.h"
#include "SendRecvThread.h"
#include "QueingArray.h"					// 

#define RECV_FILE_CMD_QUE_SIZE	100			// t@CMR}hpPbgpPbgi[

// pszFileName:S-JIS
CSendFileThread::CSendFileThread(CSendRecvThread* pCSendRecvThread, LPSTR pszFileName)
{
	// p[^L
	m_pCSendRecvThread = pCSendRecvThread;
	m_pszFileName = (LPSTR)calloc(strlen(pszFileName) + 1, sizeof(char));
	DISABLE_C4996
	strcpy(m_pszFileName, pszFileName);
	ENABLE_C4996

	// ϐ̏
	m_pCQueingArrayCmd = new CQueingArray(RECV_FILE_CMD_QUE_SIZE);	// 
	m_fIamZombie = FALSE;
	m_iSendFileStatus = SEND_FILE_STAT_IDLE;						// 
	m_bStartRes = 0;												// Jnv(0:l ErrorCode)
	m_bEndRes = 0;													// v(0:l ErrorCode)
	m_bAbortRes = 0;												// fv(0:l/ErrorCode)
	m_dwSendReqTime = 0;											// ҂^CAEĝߗvs
	m_lTotalSize = 0;												// 
}

CSendFileThread::~CSendFileThread()
{
	SAFE_FREE(m_pszFileName)
	SAFE_DELETE(m_pCQueingArrayCmd)									//
}

UINT CSendFileThread::DoWork()
{
	int		fdSrcFile;				// Mt@CfBXNv^
	struct stat statInfo;			// t@C̏̂߂̕ϐ
	long	lFileLength;
	int		iRet = -1;

	// t@COpen
	DISABLE_C4996
	fdSrcFile = _open(m_pszFileName, _O_RDONLY | _O_BINARY);
	ENABLE_C4996
	// opens͉Ȃ
	if (fdSrcFile == -1)
	{
		fprintf(stderr, "t@CopenG[ %s\n", m_pszFileName);
		goto L_END;
	}
	// t@C̏擾
	if (fstat(fdSrcFile, &statInfo) != 0)
		goto L_END;
	lFileLength = statInfo.st_size;
	m_lTotalSize = 0;

	while (!m_fStopFlag)
	{
		Sleep(5);							// Sleepđ̃XbhɃ`X^
		if ((iRet = AnalyzeCmd()) == -1)	// Ԓl-1̎G[
			break;
		if ((iRet = DoSequence(fdSrcFile, lFileLength)) == -1)
			break;
		if ((m_iSendFileStatus == SEND_FILE_STAT_END) || (m_iSendFileStatus == SEND_FILE_STAT_ABORTED))
			break;
	}
L_END:
	// t@Cclose
	if (fdSrcFile != -1)
		_close(fdSrcFile);
	m_fIamZombie = TRUE;		// t@CM/sŃ]r
	return((iRet == -1) ? -1 : 0);
}

//----------------------------------------------
// function
//		t@CMR}hpPbg̉
// parameter
//		Ȃ
// retun
//		0:t@CMR}hpPbgȂ 1:͐ -1:͎s
//----------------------------------------------
int CSendFileThread::AnalyzeCmd()
{
	int			iRet = 0, iSize;
	LPBYTE		pbPacketData = NULL;
	int			iPacketSize;
	HeaderRec* pHeader;
	WORD		wCmd;

	if ((iSize = m_pCQueingArrayCmd->GetSize()) == 0)
		goto L_END;
	// pPbg̓ǂݍ
	m_pCQueingArrayCmd->PopData(&pbPacketData, &iPacketSize);
	// R}h^Cv𒲂ׂ
	pHeader = (HeaderRec*)pbPacketData;
	wCmd = ntohs(pHeader->wCommand);
	switch (wCmd)
	{
		case CMD_SEND_FILE_START_RES:		// MJnvM
			iRet = 1;
			m_bStartRes = ((SendFileResRec*)pbPacketData)->bStatus;
			break;
		case CMD_SEND_FILE_END_RES:			// MvM
			iRet = 1;
			m_bEndRes = ((SendFileResRec*)pbPacketData)->bStatus;
			break;
		case CMD_SEND_FILE_ABORT_RES:		// MfvM
			iRet = 1;
			m_bAbortRes = ((SendFileResRec*)pbPacketData)->bStatus;
			break;
		default:
			iRet = -1;
			break;
	}
L_END:
	SAFE_FREE(pbPacketData);
	return(iRet);
}


//----------------------------------------------
// function
//		t@CMJڏԂɉs
// parameter
//		int		fdSrcFile	[in]Mt@CfBXNv^
//		long	lFileLength	[in]t@CTCY
// return
//		0:Ȃ 1:s -1:G[
//----------------------------------------------
int CSendFileThread::DoSequence(int fdSrcFile, long lFileLength)
{
	int		iRet = 0;

	switch (m_iSendFileStatus)
	{
		case SEND_FILE_STAT_IDLE:		// t@C, t@C̑M
			if (SendStartPacket(m_pszFileName, lFileLength) == TRUE)
			{
				m_iSendFileStatus = SEND_FILE_STAT_STARTING;
				m_dwSendReqTime = timeGetTime();
				iRet = 1;
			}
			else
				iRet = -1;
			break;
		case SEND_FILE_STAT_STARTING:	// ҂
			if ((iRet = CheckStartRes(TIMEOUT_FOR_RES)) == 1)
			{
				m_iSendFileStatus = SEND_FILE_STAT_ING;
				m_lTotalSize = 0;
			}
			break;
		case SEND_FILE_STAT_ING:		// t@CǂݍőM
			if ((iRet = SendIngEndPacket(fdSrcFile, lFileLength)) == 2)
			{
				iRet = 1;
				m_iSendFileStatus = SEND_FILE_STAT_ENDING;
				m_dwSendReqTime = timeGetTime();
			}
			break;
		case SEND_FILE_STAT_ENDING:	// ҂
			if ((iRet = CheckEndRes(TIMEOUT_FOR_RES)) == 1)
			{
				fprintf(stderr, "t@CM (%u) ", timeGetTime());
				m_iSendFileStatus = SEND_FILE_STAT_END;
			}
			break;
		case SEND_FILE_STAT_ABORT:		// fvM
			if (SendAbortPacket() == TRUE)
			{
				m_iSendFileStatus = SEND_FILE_STAT_ABORTING;
				m_dwSendReqTime = timeGetTime();
				iRet = 1;
			}
			break;
		case SEND_FILE_STAT_ABORTING:	// ҂
			if (((iRet = CheckAbortRes(TIMEOUT_FOR_RES)) == 1) || (iRet == -1))
			{
				fprintf(stderr, "t@CMf");
				m_iSendFileStatus = SEND_FILE_STAT_ABORTED;
			}
			break;
	}
	return(iRet);
}


//----------------------------------------------
// function
//		t@CMJnR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C(S-JIS)
//		int		iFileLength	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendStartPacket(LPSTR pszFileName, int iFileLength)
{
	BOOL		fRet = FALSE;
	SendFileStartReqRec* pSendFileStartReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	iPacketSize = sizeof(SendFileStartReqRec);
	pSendFileStartReq = (SendFileStartReqRec*)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileStartReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileStartReq->header.wCommand = htons(CMD_SEND_FILE_START_REQ);
	pSendFileStartReq->header.wDataLen = htons(sizeof(FileInfoRec));

	fprintf(stderr, "t@CMJn %s %d", pszFileName, iFileLength);
	// 	t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);
	memcpy(pSendFileStartReq->FileInfo.szFileName, pbDest, iSize);
	DISABLE_C4996
	sprintf(pSendFileStartReq->FileInfo.szFileSize, "%d", iFileLength);
	ENABLE_C4996

	fRet = m_pCSendRecvThread->SetSendData((char*)pSendFileStartReq, iPacketSize);
	SAFE_FREE(pbDest)
	SAFE_FREE(pSendFileStartReq);
	return(fRet);
}

#define	READ_SIZE	(1024 * 10)			// t@C̓ǂݍݒP(KobƓǂ݂܂)
//----------------------------------------------
// function
//		t@Cǂݍ݃t@CMR}h̑M
// parameter
//		int		fd			[in]t@CfBXNv^
//		int		iFileLength	[in]t@C
// retun
//		-1:G[ 0:񑗐MłȂ 1:r̃pPbg𑗐M 2:pPbg𑗐M
//----------------------------------------------
int CSendFileThread::SendIngEndPacket(int fd, int iFileLength)
{
	int				iRet = 1;
	BOOL			fEnd = FALSE;
	LPBYTE			pbData = NULL;
	int				iReadSize;
	SendFileIngRec* pSendFileIng = NULL;
	int				iPacketSize;
	WORD			wDataLen;

	pbData = (LPBYTE)calloc(READ_SIZE, sizeof(BYTE));
	if (_lseek(fd, m_lTotalSize, SEEK_SET) == -1)
	{
		iRet = -1;
		goto L_END;
	}
	if((iReadSize = _read(fd, pbData, READ_SIZE)) == -1)
	{
		iRet = -1;
		goto L_END;
	}

	iPacketSize = sizeof(HeaderRec) + sizeof(SendFileStatRec) + iReadSize;
	pSendFileIng = (SendFileIngRec*)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileIng->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	wDataLen = (WORD)(sizeof(SendFileStatRec) + iReadSize);
	pSendFileIng->header.wDataLen = htons(wDataLen);
	DISABLE_C4996
	sprintf(pSendFileIng->Stat.szOffset, "%d", m_lTotalSize);
	sprintf(pSendFileIng->Stat.szSize, "%d", iReadSize);
	ENABLE_C4996
	if (iReadSize > 0)			// t@C̓r𑗐M
	{
		fprintf(stderr, "t@CM %d %d %d", m_lTotalSize, iReadSize, iFileLength);
		pSendFileIng->header.wCommand = htons(CMD_SEND_FILE_ING);
		memcpy(pSendFileIng->bData, pbData, iReadSize);
	}
	else										// t@C̍Ō܂œǂ񂾂̂Ŋ𑗐M
	{
		fprintf(stderr, "t@CMM %d %d\n", m_lTotalSize, iReadSize);
		pSendFileIng->header.wCommand = htons(CMD_SEND_FILE_END_REQ);
		fEnd = TRUE;				// t@CM
	}
	// pPbgŜ𑗐Mobt@ɏ
	if (m_pCSendRecvThread->SetSendData((char*)pSendFileIng, iPacketSize) == TRUE)
	{
		if (fEnd == TRUE)					// Ō܂őM̂ŏI
		{
			iRet = 2;
			goto L_END;
		}
		m_lTotalSize += iReadSize;			// ߂̂œǂݍ݃|C^XV
		iRet = 1;
	}
	else
	{
		iRet = 0;
		fprintf(stderr, "Mobt@̋󂫑҂");	// Mobt@ɏȂ̂łƑ҂
		Sleep(100);							// READ_SIZE𑗐M̂Ɋ|鎞Ԓx҂̂ǂł傤
	}
L_END:
	SAFE_FREE(pSendFileIng)
	SAFE_FREE(pbData)
	return(iRet);
}

//----------------------------------------------
// function
//		MfR}h̑M
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendAbortPacket()
{
	BOOL		fRet = FALSE;
	SendFileAbortReqRec* pSendFileAbortReq = NULL;
	int			iPacketSize;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(SendFileAbortReqRec);
	pSendFileAbortReq = (SendFileAbortReqRec*)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileAbortReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileAbortReq->header.wCommand = htons(CMD_SEND_FILE_ABORT_REQ);
	pSendFileAbortReq->header.wDataLen = htons(0);

	fprintf(stderr, "t@CMfvM");

	// t@CMfpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char*)pSendFileAbortReq, iPacketSize);
	SAFE_FREE(pSendFileAbortReq);
	return(fRet);
}

//----------------------------------------------
// function
//		t@CMJnṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ/-1:G[,^CAEg
//----------------------------------------------
int CSendFileThread::CheckStartRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwSendReqTime) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_bStartRes == 0)										// Ȃ
		goto L_END;
	else if (m_bStartRes == ERR_SUCCESS)		// 
		iRet = 1;
	else																	// G[
	{
		fprintf(stderr, "Err:CheckStartRes %d\n", (char)m_bStartRes);
		iRet = -1;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ/-1:G[,^CAEg
//----------------------------------------------
int CSendFileThread::CheckEndRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwSendReqTime) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_bEndRes == 0)						// Ȃ
		goto L_END;
	else if (m_bEndRes == ERR_SUCCESS)		// 
		iRet = 1;
	else									// G[
	{
		fprintf(stderr, "Err:CheckEndRes %d\n", (char)m_bEndRes);
		iRet = -1;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMfṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ/-1:G[,^CAEg
//----------------------------------------------
int CSendFileThread::CheckAbortRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwSendReqTime) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_bAbortRes == 0)						// Ȃ
		goto L_END;
	else if (m_bAbortRes == ERR_SUCCESS)		// 
		iRet = 1;
	else										// G[
	{
		fprintf(stderr, "Err:CheckAbortRes %d\n", (char)m_bAbortRes);
		iRet = -1;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		Mf
//		JڏԕύXAfpPbgM
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendFileAbort()
{
	BOOL		fRet = FALSE;

	// t@CM̎f
	if (m_iSendFileStatus != SEND_FILE_STAT_ING)
		goto L_END;
	m_iSendFileStatus = SEND_FILE_STAT_ABORT;
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendFileThread::IsZombie()
{
	BOOL	fRet;

	fRet = m_fIamZombie;
	return(fRet);
}
